'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ComponentLink = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _jsExtensions = require('@jenkins-cd/js-extensions');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ComponentLink = exports.ComponentLink = (_temp = _class = function () {
    function ComponentLink(props) {
        _classCallCheck(this, ComponentLink);

        if (props) {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = Object.keys(props)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var key = _step.value;

                    this[key] = props[key];
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }

    _createClass(ComponentLink, [{
        key: 'view',
        get: function get() {
            var children = this.component;
            return function (_SandboxedComponent) {
                _inherits(ViewRenderer, _SandboxedComponent);

                function ViewRenderer(props) {
                    _classCallCheck(this, ViewRenderer);

                    var _this = _possibleConstructorReturn(this, (ViewRenderer.__proto__ || Object.getPrototypeOf(ViewRenderer)).call(this));

                    _this.children = children;
                    return _this;
                }

                return ViewRenderer;
            }(_jsExtensions.SandboxedComponent);
        }
    }]);

    return ComponentLink;
}(), _class.propTypes = {
    name: _react.PropTypes.string.isRequired,
    title: _react.PropTypes.string.isRequired,
    notification: _react.PropTypes.string,
    component: _react.PropTypes.element.isRequired
}, _temp);
//# sourceMappingURL=ComponentLink.js.map
